; GUI #
;This program demonstrates using mipmaps for texture maps.  To overtly show the
;effect of mipmaps, each mipmap reduction level has a solidly colored, contrasting
;texture image.  Thus, the quadrilateral which is drawn is drawn with several
;different colors.
include win64a.inc
; --------------- 
Wwd equ 400
Wht equ 400

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	push	sizeof WNDCLASSEX       ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	Wht
	push	Wwd
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
        cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp     NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC  ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   )
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax; 
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax;  
	invoke	wglCreateContext,hDC;     OpenGL
	mov	hrc,rax
	invoke	wglMakeCurrent,hDC,eax;   
        invoke  glEnable, GL_DEPTH_TEST
     invoke  glShadeModel, GL_FLAT
	movd	xmm0,ebx
	movd	xmm1,ebx
	movd	xmm2,const_3_6
     invoke  glTranslatef
     call    makeImages
     invoke  glPixelStorei, GL_UNPACK_ALIGNMENT, 1
     invoke  glTexParameteri, GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT
     invoke  glTexParameteri, GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT
     invoke  glTexParameteri, GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST
     invoke  glTexParameteri, GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST_MIPMAP_NEAREST
	mov	eax,offset mipmapImage32
     invoke  glTexImage2D,GL_TEXTURE_2D,0,GL_RGBA,32,32,0,GL_RGBA,GL_UNSIGNED_BYTE,rax	     
	mov	eax,offset mipmapImage16
     invoke  glTexImage2D,GL_TEXTURE_2D,1,GL_RGBA,16,16,0, GL_RGBA, GL_UNSIGNED_BYTE,rax
	mov	eax,offset mipmapImage8
     invoke  glTexImage2D,GL_TEXTURE_2D,2,GL_RGBA,8,8,0,GL_RGBA,GL_UNSIGNED_BYTE,rax
	mov	eax,offset mipmapImage4
     invoke  glTexImage2D,GL_TEXTURE_2D,3,GL_RGBA,4,4,0,GL_RGBA, GL_UNSIGNED_BYTE,rax
	mov	eax,offset mipmapImage2
     invoke  glTexImage2D,GL_TEXTURE_2D,4,GL_RGBA,2,2,0,GL_RGBA, GL_UNSIGNED_BYTE,rax
	mov	eax,offset mipmapImage1
     invoke  glTexImage2D,GL_TEXTURE_2D,5,GL_RGBA,1,1,0,GL_RGBA, GL_UNSIGNED_BYTE,rax	    
     invoke  glTexEnvf, GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL
     invoke  glEnable, GL_TEXTURE_2D
     invoke	GLReshape	
	jmp	wmBYE
wmSIZE:; --------------- Resize the scene
        movzx	r8,r9w
	shr	r9,16
	invoke	glViewport,0,0
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
; --------------- Display the scene
	lea	edx,ps
        invoke  BeginPaint
        invoke  glClear, GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	invoke  glBegin, GL_QUADS
	movd	xmm0,ebx
	movd	xmm1,ebx	
	invoke  glTexCoord2f
	movd	xmm0,const_2_0
	movd	xmm1,const_1_0
	movd	xmm2,ebx
	invoke  glVertex3f
	movd	xmm0,ebx
	movd	xmm1,const8_0
	invoke  glTexCoord2f
	movd	xmm0,const_2_0
	movd	xmm1,const1_0
	movd	xmm2,ebx
	invoke  glVertex3f
	movd	xmm0,const8_0
	movd	xmm1,const8_0
	invoke  glTexCoord2f
	movd	xmm0,const2000_0
	movd	xmm1,const1_0
	movd	xmm2,const_6000_0
	invoke  glVertex3f
	movd	xmm0,const8_0
	movd	xmm1,ebx
	invoke  glTexCoord2f
	movd	xmm0,const2000_0
	movd	xmm1,const_1_0
	movd	xmm2,const_6000_0
	invoke  glVertex3f
	invoke  glEnd
	invoke  glFlush
        invoke	SwapBuffers,hDC
	lea	edx,ps
        invoke  EndPaint,hWin
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp
makeImages proc
local	j:DWORD
local	i:DWORD

	mov     i, 0 ;for (i = 0; i < 32; i++)
@0:  ;   .repeat
	mov     j, 0 ;for (j = 0; j < 32; j++)
@@:	;     .repeat
	mov     eax, 32
	mul     i
	add     eax, j
	shl     eax, 2
	mov     mipmapImage32[rax], 255
	mov     mipmapImage32[rax+1], 255
	mov     mipmapImage32[rax+2], 0
	mov     mipmapImage32[rax+3], 255
	inc     j
	cmp	j,32
	jc	@b
	inc     i
	cmp	i,32
	jc	@0
	mov     i, 0 ;for (i = 0; i < 16; i++)
@1:     ;.repeat
	mov     j, 0 ;for (j = 0; j < 16; j++)
@@:;	     .repeat
	mov     eax, 16
	mul     i
	add     eax, j
	shl     eax, 2
	mov     mipmapImage16[rax], 255
	mov     mipmapImage16[rax + 1], 0
	mov     mipmapImage16[rax + 2], 255
	mov     mipmapImage16[rax + 3], 255
	inc     j
	cmp	j,16
	jc	@b
	inc     i
	cmp	i,16
	jc	@1
	mov     i, 0 ;for (i = 0; i < 8; i++)
@2:;     .repeat
	mov     j, 0 ;for (j = 0; j < 8; j++)
@@:;	     .repeat
	mov     eax, 8
	mul     i
	add     eax, j
	shl     eax, 2
	mov     mipmapImage8[rax], 255
	mov     mipmapImage8[rax + 1], 0
	mov     mipmapImage8[rax + 2], 0
	mov     mipmapImage8[rax + 3], 255
	inc     j
	cmp	j,8
	jc	@b
	inc     i
	cmp	i,8
	jc	@2
	mov     i, 0 ;for (i = 0; i < 4; i++)
@3:;     .repeat
	mov     j, 0 ;for (j = 0; j < 4; j++)
@@:;	     .repeat
	mov     eax, 4
	mul     i
	add     eax, j
	shl     eax, 2
	mov     mipmapImage4[rax], 0
	mov     mipmapImage4[rax + 1], 255
	mov     mipmapImage4[rax + 2], 0
	mov     mipmapImage4[rax + 3], 255
	inc     j
	cmp	j,4
	jc	@b
	inc     i
	cmp	i,4
	jc	@3
	mov     i, 0 ;for (i = 0; i < 2; i++)
@4:;     .repeat
	mov     j, 0 ;for (j = 0; j < 2; j++)
@@:;	     .repeat
	mov     eax, 2
	mul     i
	add     eax, j
	shl     eax, 2
	mov     mipmapImage2[rax], 0
	mov     mipmapImage2[rax + 1], 0
	mov     mipmapImage2[rax + 2], 255
	mov     mipmapImage2[rax + 3], 255
	inc     j
	cmp	j,2
	jc	@b
	inc     i
	cmp	i,2
	jc	@4
	mov     mipmapImage1, 255
	mov     mipmapImage1 + 1, 255
	mov     mipmapImage1 + 2, 255
	mov     mipmapImage1 + 3, 255
	leave
	retn
makeImages endp
GLReshape proc; 	w, h
;local resultq:QWORD
	enter 40h,0
     fninit
     invoke  glViewport, 0, 0,400,400
     invoke  glMatrixMode, GL_PROJECTION
     invoke  glLoadIdentity
	movq	xmm3,constd30000_0
	movq	xmm2,constd1_0
	movq	xmm1,constd1_4
	movq	xmm0,constd60_0
	invoke  gluPerspective
     invoke  glMatrixMode, GL_MODELVIEW
     invoke  glLoadIdentity
	leave
     retn
GLReshape endp
hDC	dq	?
hrc	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "OpenGL - Using MipMaps for Texture maps",0
FileName	db "..\..\br_Rabbit3.cur",0
mipmapImage32	db 32*32*4 dup(?)
mipmapImage16	db 16*16*4 dup(?)
mipmapImage8	db 8*8*4 dup(?)
mipmapImage4	db 4*4*4 dup(?)
mipmapImage2	db 2*2*4 dup(?)
mipmapImage1	db 1*1*4 dup(?)
const1_0	dd 1.0
const8_0	dd 8.0
const2000_0	dd 2000.0
const_1_0	dd -1.0
const_2_0       dd -2.0
const_3_6	dd -3.6
const_6000_0	dd -6000.0
constd1_0	dq 1.0
constd1_4	dq 1.4
constd60_0	dq 60.0
constd30000_0	dq 30000.0
end